#include <string.h>


#include <assert.h>
#include <stdio.h>
#include <stdlib.h>	
#include <string.h>	
		
// base64 tables	
static char basis_64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";	
#define CHAR64(c)  (((c) < 0 || (c) > 127) ? -1 : index_64[(c)])
int passwd_xor(char*  target, char * srcXOR, char*  dest);
char * base64_encode(const unsigned char *value, int vlen);	
unsigned char * base64_decode(const char *value, int *rlen);
	
static signed char index_64[128] = {	
	    -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,	
	    -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,	
	    -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,62, -1,-1,-1,63,	
	    52,53,54,55, 56,57,58,59, 60,61,-1,-1, -1,-1,-1,-1,	
	    -1, 0, 1, 2,  3, 4, 5, 6,  7, 8, 9,10, 11,12,13,14,	
	    15,16,17,18, 19,20,21,22, 23,24,25,-1, -1,-1,-1,-1,	
	    -1,26,27,28, 29,30,31,32, 33,34,35,36, 37,38,39,40,	
	    41,42,43,44, 45,46,47,48, 49,50,51,-1, -1,-1,-1,-1	
} ;
	
char *base64_encode(const unsigned char value[], int vlen) {
	unsigned char oval = 0 ; 	
        char *result = (char *)malloc((vlen * 4) / 3 + 5) ;	
        char *out = result;	
	while (vlen >= 3) {	
        	*out++ = basis_64[value[0] >> 2];	
        	*out++ = basis_64[((value[0] << 4) & 0x30) | (value[1] >> 4)];	
        	*out++ = basis_64[((value[1] << 2) & 0x3C) | (value[2] >> 6)];	
        	*out++ = basis_64[value[2] & 0x3F];	
        	value += 3;	
       		vlen -= 3;	
    	}
	if (vlen > 0) {	
	        *out++ = basis_64[value[0] >> 2];	
	        oval = (value[0] << 4) & 0x30 ;	
	        if (vlen > 1) oval |= value[1] >> 4;	
	        *out++ = basis_64[oval];	
	        *out++ = (vlen < 2) ? '=' : basis_64[(value[1] << 2) & 0x3C];	
	        *out++ = '=';	
	}	
	*out = '\0';		
	return result;	
}	

unsigned char* base64_decode(const char *value, int *rlen)
{		
	int c1, c2, c3, c4;	        	
        int vlen = strlen(value);	
	unsigned char *result =(unsigned char *)malloc((vlen * 3) / 4 + 1);	
	unsigned char *out = result;	
	
	*rlen = 0;
	
	while (1) {	
		if (value[0]==0) {
			*out = '\0' ; 
			return result;	
		}
	        c1 = value[0];	
                if (CHAR64(c1) == -1) goto base64_decode_error;
	             c2 = value[1];	
	             if (CHAR64(c2) == -1) goto base64_decode_error;
	             c3 = value[2];	
	             if ((c3 != '=') && (CHAR64(c3) == -1)) goto base64_decode_error;
	             c4 = value[3];	
	             if ((c4 != '=') && (CHAR64(c4) == -1)) goto base64_decode_error;	
                     value += 4;	
	             *out++ = (CHAR64(c1) << 2) | (CHAR64(c2) >> 4);	
	             *rlen += 1;	
	             if (c3 != '=') {	
	             	*out++ = ((CHAR64(c2) << 4) & 0xf0) | (CHAR64(c3) >> 2);	
	                *rlen += 1;	
	                if (c4 != '=') {	
	                	*out++ = ((CHAR64(c3) << 6) & 0xc0) | CHAR64(c4);	
	                        *rlen += 1;	
	                }
	             }	
	}	
	base64_decode_error:	
	        *result = 0;	
	        *rlen = 0;	
	        return result;	
}

const char HEX2DEC[256] = 
{
    /*       0  1  2  3   4  5  6  7   8  9  A  B   C  D  E  F */
    /* 0 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* 1 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* 2 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* 3 */  0, 1, 2, 3,  4, 5, 6, 7,  8, 9,-1,-1, -1,-1,-1,-1,
    
    /* 4 */ -1,10,11,12, 13,14,15,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* 5 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* 6 */ -1,10,11,12, 13,14,15,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* 7 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    
    /* 8 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* 9 */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* A */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* B */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    
    /* C */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* D */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* E */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
    /* F */ -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1
};

int pwd_encode(char * password, char ** encode_password)
{
	int base64_len, more_passwd_len;
	char  *more_passwd , *encpasswd;
	char * newpasswd, *random_str, *full_passwd;
	int    pwd_len;
	unsigned char  new_passwd[80], all_passwd[80];;
	int i;
	
	
	if ( password == NULL)
	{
		printf("the password is null, something is error");
		return 1;
	}
	pwd_len = strlen(password);
	if ( pwd_len > 15)
	{
		more_passwd_len = pwd_len - 15;
		more_passwd = malloc(more_passwd_len+2);
		more_passwd = strndup(password, more_passwd_len);
		password = password + more_passwd_len;
	}
	else
	{
		more_passwd_len = 0;
		more_passwd = NULL;
	}
	full_passwd = malloc(120);
	//full_passwd = strdup(password);
   	strcpy(full_passwd, password);
	if ( pwd_len < 15)
	{
		random_str = NULL;
		random_str = malloc(1024);	
	
		srand((int)time(0));
		sprintf(random_str, "%ld", random());
		if ( strlen(random_str ) < 15-pwd_len)
                {
                        strncat(random_str, "aaaaaaaaaaaaaaaa", 15-pwd_len-strlen(random_str));
                }
		full_passwd  = strcat(full_passwd, random_str);
	}
	
	newpasswd = malloc(80);
        encpasswd = malloc(80);
	sprintf(newpasswd, "%c%s", pwd_len+'A', full_passwd);  
	/* char [] */
	passwd_xor(newpasswd, "nkhaes60hacluster", encpasswd);
	for ( i=0; i<13; i++)
	{
		new_passwd[i] = (encpasswd)[3+i];  
		
	}
	for ( i=0; i<3; i++)
	{
		new_passwd[i+13] = (encpasswd)[i];  
	}
		
	base64_len = 16 + more_passwd_len;	
	if ( more_passwd_len > 0)
	{
		for ( i =0; i < more_passwd_len; i++)
		{
			all_passwd[i] = more_passwd[i];
		}
	}	
	for ( i=0; i<16; i++)
	{
		all_passwd[more_passwd_len+i] = new_passwd[i];
		
	}
	*encode_password = base64_encode(all_passwd, base64_len);
	return 0;
}
int pwd_decode(char * password, char ** decode_password)
{
	int base64_len, more_passwd_len, enc_passwd_len;
	unsigned char  *encpasswd;
	unsigned char more_passwd[80]; 
	unsigned char  new_passwd[80];
	char * newptr;
	int    pwd_len;
	char *newpasswd;
	int  i;
	
	
	if ( password == NULL)
	{
		printf("the password is null, something is error");
		return 1;
	}
	else
	{
		//printf(" the password is %s\n", password);
	}
	
	encpasswd = base64_decode(password, &base64_len);
	enc_passwd_len = base64_len; 
	if ( enc_passwd_len > 16)
	{
		more_passwd_len = enc_passwd_len - 16;
		for ( i =0; i < more_passwd_len; i++)
		{
			more_passwd[i] = (encpasswd)[i];
		}
		more_passwd[more_passwd_len] = '\0';
	
	}
	else
	{
		more_passwd_len = 0;
	}
	for ( i=0; i<3; i++)
	{
		new_passwd[i] = (encpasswd)[more_passwd_len+i+13];  
		
	}
	for ( i=0; i<13; i++)
	{
		new_passwd[i+3] = (encpasswd)[more_passwd_len+i];  
	}
		
	/* begin xor */
	newpasswd = malloc(80);
	newptr = (char *)new_passwd;
	passwd_xor(newptr, "nkhaes60hacluster", newpasswd);
	
	pwd_len = *(strndup(newpasswd, 1)) - 'A';
	if ( pwd_len > 15)
	{
		strcat((char*)more_passwd, newpasswd+1);	
		*decode_password = strdup(more_passwd);
	}
	else
	{
		*decode_password = strndup(newpasswd+1, pwd_len);
	}
        return 0;	
}
int passwd_xor(char*  target, char * srcXOR, char*  dest)
{
	int length = 16;
	int len;
	int i;

	char strRes[1024]={0};
	len = strlen(srcXOR);	
	for( i=0;i<length;i++)
	    {
		int j=i%len;
		int t;
		t=target[i]^srcXOR[j];
		strRes[i]=(char)t;
	    }
	for( i=0;i<length;i++)
	{
		dest[i] = strRes[i];	
	}

	 return 0;
}
